// musala.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "time.h"

FILE *inp_file;

typedef unsigned long uint;
typedef long sint;
typedef unsigned long long uint64;
typedef signed long long sint64;

#define TIMELIMIT (2000)
#define CHK_TIME() (clock() - start_time < TIMELIMIT)

#define DAYS (64)
#define MONTHS (4)
#define HOURS (16)

typedef struct ship_struct ship_t;
struct ship_struct{
	int start_planet;
	int speed;
	int price;
	int max_pass;
	bool used;
};

typedef struct flight_struct flight_t;
struct flight_struct{
	int start_planet;
	int end_planet;
	int dist;

	int start_time;
	int end_time;
	int month;
	int proff;
	int pass;
	bool ready;
};

typedef struct result_struct result_t;
struct result_struct{
	int start_time;
	int end_time;
	int planet;
	int start_time_2;
	int end_time_2;
};

ship_t ships[100];
result_t result[100];
result_t best_result[100];
int best_proff = 0;
bool valid = false;

flight_t flights[1024 * 1024];

int plan_look_cnt[51];

flight_t *plan_look[51][MONTHS * HOURS * 2 * 1000];
int planets_hours[51][HOURS];

int fl_cnt = 0;
int start_time = 0;

int planets_cnt = 0, flights_cnt = 0, ships_cnt = 0;


void input()
{
	fopen_s(&inp_file, "flights.in", "r");
	fscanf_s(inp_file, "%d %d %d", &planets_cnt, &ships_cnt, &flights_cnt);

	for (int i = 0; i < ships_cnt; i++){
		fscanf_s(inp_file, "%d %d %d %d", &(ships[i].start_planet), &(ships[i].speed), &(ships[i].price), &(ships[i].max_pass));
		ships[i].start_planet--;
		ships[i].used = false;
	}

	for (int i = 0; i < planets_cnt; i++){
		plan_look_cnt[i] = 0;
	}

	for (int i = 0; i < flights_cnt; i++){
		int st_pl = 0, end_pl = 0, dist = 0, k;
		fscanf_s(inp_file, "%d %d %d %d", &st_pl, &end_pl, &dist, &k);
		st_pl--;
		end_pl--;
		if (0 == k){
			flights[fl_cnt].dist = dist; flights[fl_cnt].start_planet = st_pl; flights[fl_cnt].end_planet = end_pl;
			flights[fl_cnt].start_time = 4;
			flights[fl_cnt].end_time = 15;
			flights[fl_cnt].month = 0;
			flights[fl_cnt].proff = 0;
			flights[fl_cnt].pass = 0;
			flights[fl_cnt].ready = false;

			plan_look[st_pl][plan_look_cnt[st_pl]] = flights + fl_cnt;
			plan_look_cnt[st_pl]++;
			fl_cnt++;

		} else for (int j = 0; j < k; j++){
			flights[fl_cnt].dist = dist; flights[fl_cnt].start_planet = st_pl; flights[fl_cnt].end_planet = end_pl;

			fscanf_s(inp_file, "%d %d %d %d %d", &(flights[fl_cnt].start_time), &(flights[fl_cnt].end_time), &(flights[fl_cnt].month), &(flights[fl_cnt].proff), &(flights[fl_cnt].pass));
			flights[fl_cnt].ready = false;

			plan_look[st_pl][plan_look_cnt[st_pl]] = flights + fl_cnt;
			plan_look_cnt[st_pl]++;
			fl_cnt++;
		}
	}
	fclose(inp_file);

}


void find()
{
	int start = rand() % ships_cnt;
	int company_proff = 0;

	for (int i = 0; i < planets_cnt; i++){
		for (int j = 0; j < plan_look_cnt[i]; j++){
			plan_look[i][j]->ready = false;
		}
		for (int j = 4; j < HOURS; j++){
			planets_hours[i][j] = 0;
		}
		planets_hours[i][0] = planets_hours[i][1] = planets_hours[i][2] = planets_hours[i][3] = 1;
	}

	for (int i = 0; i < ships_cnt; i++){
		int sh = (i + start) % ships_cnt;
		int best_ship_proff = 0;
		bool valid_ship = false;

		int pl = ships[sh].start_planet;

		flight_t *best_flights[2];
		best_flights[0] = best_flights[1] = NULL;

		int start_time1[2];
		int start_time2[2];
		int end_time2[2];

		int planets1[2];


		int proff = 0; 

		for (int j = 0; j < plan_look_cnt[pl]; j++){
			flight_t *flight = plan_look[pl][j];
			if ((flight->ready) || (flight->start_planet != pl))
				continue;
			
			int tm1 = flight->dist / ships[sh].speed;
			int min1 = (flight->dist % ships[sh].speed)?1:0;
			if (tm1 + min1 + flight->start_time > HOURS)
				continue;

			proff = 0;
			proff -= (ships[sh].price * flight->dist);
			int pass = (ships[sh].max_pass < flight->pass)?ships[sh].max_pass:flight->pass;
			if (tm1 + min1 + flight->start_time <= flight->end_time)
				proff += (pass * flight->proff);

			int pl2 = flight->end_planet;
			int best_ship_proff2 = 0;
			bool valid_ship2 = false;
			flight_t *best_fl2 = NULL;
			int proff2 = 0;
			flight_t *flight2 = NULL;

			for (int k = 0; k < plan_look_cnt[pl2]; k++){
				flight2 = plan_look[pl2][k];
				if ((flight2->ready) || (flight2->end_planet != pl))
					continue;

				int tm2 = flight2->dist / ships[sh].speed;
				int min2 = (flight2->dist % ships[sh].speed)?1:0;
				if (tm2 + min2 + flight2->start_time > HOURS)
					continue;

				proff2 = 0;

				proff2 -= (ships[sh].price * flight2->dist);
				int pass2 = (ships[sh].max_pass < flight2->pass)?ships[sh].max_pass:flight2->pass;
				if (tm2 + min2 + flight2->start_time <= flight2->end_time)
					proff2 += (pass2 * flight2->proff);

				if ((false == valid_ship2) || (proff2 > best_ship_proff2)){
					valid_ship2 = true;
					best_fl2 = flight2;
					best_ship_proff2 = proff2;
				}
			}

			if ((false == valid_ship2) && (false == valid_ship)){
				// TODO : Find any planet (2)
				for (int k = 0; k < plan_look_cnt[pl2]; k++){
					flight_t *flight3 = plan_look[pl2][k];
					if (flight3->end_planet != pl){
						continue;
					}
					int tm3 = flight3->dist / ships[sh].speed;
					int min3 = (flight3->dist % ships[sh].speed)?1:0;
					if (tm3 + min3 > 12)
						break;
					for (int t = 4; t < HOURS - tm3 - min3; t++){
						if (0 == planets_hours[pl2][t]){
							start_time2[1] = t;
							end_time2[1] = tm3 + min3 + t;
							valid_ship2 = true;
							break;
						}
					}
					break;
				}
			}

			proff += proff2;

			if (((false == valid_ship) || (proff > best_ship_proff)) && (valid_ship2)){
				best_flights[0] = flight;
				best_flights[1] = flight2;
				valid_ship = true;
				best_ship_proff = proff;
			}
		}
		if (false == valid_ship){
			int aaa = 23;
			// TODO :
		}
		company_proff += proff;
		result[sh].planet = best_flights[0]->end_planet;
		result[sh].start_time = best_flights[0]->start_time;
		result[sh].end_time = best_flights[0]->dist / ships[sh].speed;
		result[sh].end_time += (best_flights[0]->dist % ships[sh].speed)?1:0;

		planets_hours[pl][best_flights[0]->start_time] = 1;
		planets_hours[best_flights[0]->end_planet][best_flights[1]->start_time] = 1;

		if (best_flights[1]){
			result[sh].start_time_2 = best_flights[1]->start_time;
			result[sh].end_time_2 = best_flights[1]->dist / ships[sh].speed;
			result[sh].end_time_2 += (best_flights[1]->dist % ships[sh].speed)?1:0;
		} else {
			result[sh].start_time_2 = start_time2[1];
			result[sh].end_time_2 = end_time2[1];
		}

		best_flights[0]->ready = true;
		best_flights[1]->ready = true;
	}

	if ((false == valid) || (company_proff > best_proff)){
		valid = true;
		for (int r = 0; r < ships_cnt; r++){
			best_result[r] = result[r];
		}
		best_proff = company_proff;
	}

}

int _tmain(int argc, _TCHAR* argv[])
{
	start_time = clock();

	input();
	find();

	FILE *out_f = NULL;
	fopen_s(&out_f, "flights.out", "w");

	for (int i = 0; i < ships_cnt; i++){
		int cyc = 0;
		if (best_result[i].start_time_2 > best_result[i].start_time){
			fprintf_s(out_f, "8\n");
			cyc = 4;
		} else {
			fprintf_s(out_f, "4\n");
			cyc = 2;
		}

		int day = 1;
		for (int j = 0; j < cyc; j++){
			fprintf_s(out_f, "%d %d %d\n", day, best_result[i].start_time, best_result[i].planet+1);
			if (2 == cyc)
				day++;
			fprintf(out_f, "%d %d %d\n", day, best_result[i].start_time_2, ships[i].start_planet+1);
			day++;
		}
	}
	return 0;
}

